function BuildScreen() {
  
  this.show = false;
  
  this.unlockedWaterFood = false;
  this.unlockedBeds = false;
  this.unlockedAll = false;
  
  this.choice = [
    { type : "B", name : "ventilation system", price : { metal : 5 }, hint : "produces fresh air  A.", toUnlock : "V xyz" },
    { type : "C", name : "water pump", price : { metal : 10 }, hint : "produces water  W.", toUnlock : "V  you need a ventilation system to build this facility." },
    { type : "D", name : "hydroponic field", price : { metal : 10 }, hint : "produces food  F.", toUnlock : "V  you need a ventilation system to build this facility." },
    { type : "E", name : "bedroom", price : { metal : 20 }, hint : "each bed will increase your population by one.", toUnlock : "V  you need food and water in storage to build this facility." },
    { type : "G", name : "generator", price : { metal : 50, cement : 10 }, hint : "produces electricity  E  out of biomass  B.", toUnlock : "V  you need at least a population of 5 to build this facility." },
    { type : "H", name : "recycling center", price : { metal : 50, electronics : 3 }, hint : "produces biomass  B.", toUnlock : "V  you need at least a population of 5 to build this facility." },
    { type : "I", name : "storage room", price : { metal : 50 }, hint : "increases the maximum storage of your bunker.", toUnlock : "V  you need at least a population of 5 to build this facility." },
    { type : "F", name : "communications center", price : { metal : 100, electronics : 20 }, hint : "warns you of air raids."/* and allows you to enter other bunkers."*/, toUnlock : "V  you need at least a population of 5 to build this facility." },
  ];
  
  this.resChar = {
    metal : "M",
    cement : "C",
    electronics : "L",
  };
  
  this.selection = -1;
  
  this.text;
  
  
  this.init = function() {
    this.text = new Text();
    this.text.setFont("normal");
    this.text.setAlignment(Text.CENTER);
  };
  
  
  this.open = function() {
    this.show = true;
    this.selection = -1;
    
    if(bunker.rooms[0].type == "venti") {
      this.unlockedWaterFood = true;
    }
    if(bunker.inv.water > 0 && bunker.inv.food > 0 ) {
      this.unlockedBeds = true;
    }
    if(bunker.population >= 5) {
      this.unlockedAll = true;
    }
    
    for(var i = 0; i < this.unlockedUntil(); i++) {
      var x = (i % 2 == 0 ? 280 : 488);
      var y = (90 + Math.floor(i / 2) * 90);
      mouse.registerDownArea("buildFacility" + i, x, y, 192, 78, function() {
        buildScreen.selection = (Math.floor((mouse.y - 90) / 90) * 2) + (mouse.x > 480 ? 1 : 0);
      });
    }
    mouse.registerUpArea("buildFacilityBuild", 352, 450, 90, 42, function() {
      if(buildScreen.selection != -1) {
        buildScreen.tryBuildingRoom();
      }
    });
    mouse.registerUpArea("buildFacilityCancel", 518, 450, 90, 42, function() {
      buildScreen.close();
    });
  };
  
  
  this.tryBuildingRoom = function() {
    var facility = this.choice[this.selection];
    var enoughRes = true;
    for(var res in facility.price) {
      if(bunker.inv[res] < facility.price[res]) {
        enoughRes = false;
      }
    }
    
    if(enoughRes) {
      for(var res in facility.price) {
        bunker.inv[res] -= facility.price[res];
      }
      bunker.buildFacility(facility.type);
      buildScreen.close();
    } else {
      hint.setText("V  you don't have enough resources in your bunker to build this facility.", 120, 3);
    }
  };
  
  
  this.close = function() {
    this.show = false;
    for(var i = 0; i < this.unlockedUntil(); i++) {
      mouse.deleteDownArea("buildFacility" + i);
    }
    mouse.deleteUpArea("buildFacilityBuild");
    mouse.deleteUpArea("buildFacilityCancel");
  };
  
  
  this.unlockedUntil = function() {
    var unlocked = 1;
    if(this.unlockedWaterFood) {
      unlocked = 3;
    }
    if(this.unlockedBeds) {
      unlocked = 4;
    }
    if(this.unlockedAll) {
      unlocked = 8;
    }
    return unlocked;
  };
  
  
  this.draw = function() {
    if(this.show) {
      img.draw("buildScreen", 0, 0);
    
      for(var i = 0; i < this.choice.length; i++) {
        var name = this.choice[i].name;
        var price = this.choice[i].price;
        var hintText = this.choice[i].hint;
        
        var x = (i % 2 == 0 ? 280 : 488);
        var y = (90 + Math.floor(i / 2) * 90);
        
        var textOffset = 0;
        
        if(mouse.isOver(x, y, 192, 78)) {
          img.drawSprite("buildSelection", x, y, 200, 80, (mouse.down ? 2 : 1), (this.selection == i ? 1 : 0));
          if(i < this.unlockedUntil()) {
            hint.setText(hintText, 1, 2);
          } else {
            hint.setText(this.choice[i].toUnlock, 1, 2);
          }
          if(mouse.down) {
            textOffset = 2;
          }
        } else {
          img.drawSprite("buildSelection", x, y, 200, 80, 0, (this.selection == i ? 1 : 0));
        }
        
        if(i >= this.unlockedUntil()) {
          c.globalAlpha = 0.2;
        }
        
        this.text.setPosition(x + 96, y + 12 + textOffset);
        this.text.text(name);
        this.text.draw();
        
        var priceTexts = [];
        for(var res in price) {
          priceTexts.push(this.resChar[res] + " " + price[res].toString());
        }
        this.text.setPosition(x + 96, y + 36 + textOffset);
        this.text.text(priceTexts.join("     "));
        this.text.draw();
        
        if(i >= this.unlockedUntil()) {
          c.globalAlpha = 1;
        }
      }
      
      if(this.selection == -1) {
        img.drawSprite("buttons", 352, 450, 100, 50, 3, 2);
      } else if(mouse.isOver(352, 450, 90, 42)) {
        img.drawSprite("buttons", 352, 450, 100, 50, (mouse.down ? 2 : 1), 2);
      } else {
        img.drawSprite("buttons", 352, 450, 100, 50, 0, 2);
      }
      
      if(mouse.isOver(518, 450, 90, 42)) {
        img.drawSprite("buttons", 518, 450, 100, 50, (mouse.down ? 2 : 1), 3);
      } else {
        img.drawSprite("buttons", 518, 450, 100, 50, 0, 3);
      }
    }
  };
  
}