function Map() {
  
  this.TILE_WIDTH = 240;
  this.TILE_HEIGHT = 160;
  
  
  this.ground = [];
  this.bunkers = [];
  this.groundWidth = 0;
  
  this.buildRoomText;
  
  this.crates = [];
  this.NUMBER_OF_CRATES = 10;
  
  
  this.tilesTextureOffset = {
    "B" : 0,
    "C" : 1,
    "D" : 2,
    "E" : 3,
    "F" : 4,
    "G" : 5,
    "H" : 6,
    "I" : 7,
  };
  
  
  this.init = function() {
    
    var roomCodes = ["B", "C", "D", "E", "F", "G", "H", "I"];
    
    for(var i = 0; i < 400; i++) {
      this.ground[i] = [];
      if(rand(0, 3) == 0) {
        for(var j = 0; j < rand(1, 10); j++) {
          this.ground[i].push({ type : roomCodes[rand(0, 7)], upgrade : 0, people: 0 });
        }
        if(rand(0, 1) == 0) {
          this.bunkers[i] = { owner : "One name", accessible : false };
        } else {
          this.bunkers[i] = { owner : "One name", accessible : false };
        }
      } else {
        this.bunkers[i] = { owner : false, accessible : false };
      }
    }
    this.groundWidth = this.ground.length;
    
    mouse.registerUpArea("buildBunker", (game.WIDTH / 2) - 200, (game.HEIGHT / 2), 400, (game.HEIGHT / 2), function() {
      var thisBunker = map.ground[player.onBunker];
      var posX = (game.WIDTH / 2) - (player.x % map.TILE_WIDTH);
      if(!player.hasBunker &&
          thisBunker.length == 0 &&
          (player.x % map.TILE_WIDTH) >= 80 &&
          (player.x % map.TILE_WIDTH) < 160 &&
          !buildScreen.show) {
        var posY = 0 - (player.y - (game.HEIGHT / 2));
        if(mouse.isOver(posX + 20, posY + 20, map.TILE_WIDTH - 40, map.TILE_HEIGHT - 40)) {
          var nextRoomCost = { cement : 5, metal : 2 };
          if(player.inv.cement >= nextRoomCost.cement && player.inv.metal >= nextRoomCost.metal) {
            player.inv.cement -= nextRoomCost.cement;
            player.inv.metal -= nextRoomCost.metal;
            player.buildBunker();
          } else {
            hint.setText("V  you don't have enough resources to build your bunker.", 150, 3);
          }
        }
      }
      if(player.hasBunker &&
         player.onBunker == player.myBunker &&
         player.onRoom == thisBunker.length - 1 &&
         !buildScreen.show &&
         bunker.rooms[0].type == "venti") {
        var posY = (thisBunker.length * map.TILE_HEIGHT) - (player.y - (game.HEIGHT / 2));
        if(mouse.isOver(posX + 20, posY + 20, map.TILE_WIDTH - 40, map.TILE_HEIGHT - 40)) {
          var nextRoomCost = bunker.getNextRoomCost();
          if(bunker.inv.cement >= nextRoomCost.cement && bunker.inv.metal >= nextRoomCost.metal) {
            bunker.inv.cement -= nextRoomCost.cement;
            bunker.inv.metal -= nextRoomCost.metal;
            player.addRoom();
          } else {
            hint.setText("V  you don't have enough resources to add a room to your bunker.", 150, 3);
          }
        }
      }
    });
    
    this.buildRoomText = new Text();
    this.buildRoomText.setFont("normal");
    this.buildRoomText.setAlignment(Text.CENTER);
  };
  
  
  this.placeStartingCrates = function() {
    for(var i = 0; i < this.NUMBER_OF_CRATES; i++) {
      this.crates.push(0);
      var placeCrateX = rand(280, 2.5 * game.WIDTH);
      if(i < this.NUMBER_OF_CRATES / 2) {
        this.placeCrate(i, player.x + placeCrateX);
      } else {
        this.placeCrate(i, player.x - placeCrateX);
      }
    };
  };
  
  
  this.placeCrate = function(i, x) {
    x = 48 * Math.round(x / 48);
    while(inArray(x - 48, this.crates) || inArray(x, this.crates) || inArray(x + 48, this.crates)) {
      x += 48;
    }
    this.crates[i] = x;
  };
  
  
  this.update = function() {

  };
  
  
  this.draw = function() {
    
    var halfGameWidth = (game.WIDTH / 2);
    var halfGameHeight = (game.HEIGHT / 2);
    
    var startX = Math.round((player.x - halfGameWidth) / this.TILE_WIDTH) - 1;
    var endX = Math.round((player.x + halfGameWidth) / this.TILE_WIDTH) + 1;
    
    var startY = Math.round((player.y - halfGameHeight) / this.TILE_HEIGHT) - 1;
    var endY = Math.round((player.y + halfGameHeight) / this.TILE_HEIGHT) + 1;
    
    
    if(player.y < 300) {
      var skyPosY = -20 - ((player.y + 40) * 0.25);
      var skyPosX = 0 - (((player.x * 0.25) + 200000) % 2000);
      for(var i = 0; i < 4; i++) {
        var skyTilePosX = skyPosX + (500 * i);
        if(skyTilePosX < -520) {
          skyTilePosX += 2000;
        }
        if(skyTilePosX > -520 && skyTilePosX < 980) {
          img.drawSprite("sky", skyTilePosX, skyPosY, 500, 350, i, 0);
        }
      }
      
      if(player.hasBunker && bunker.airRaidExplosion > 0) {
        c.globalAlpha = bunker.airRaidExplosion / 5;
        c.fillStyle = "#ffe";
        c.fillRect(-20, -20, game.WIDTH + 40, 340);
        c.globalAlpha = 1;
      }
      
      var bgPosY = 150 - ((player.y + 40) * 0.5);
      var bgPosX = 0 - (((player.x * 0.5) + 200000) % 2000);
      for(var i = 0; i < 4; i++) {
        var bgTilePosX = bgPosX + (500 * i);
        if(bgTilePosX < -520) {
          bgTilePosX += 2000;
        }
        if(bgTilePosX > -520 && bgTilePosX < 980) {
          img.drawSprite("farBackground", bgTilePosX, bgPosY, 500, 150, i, 0);
        }
      }
    }
    
    var tilePosX;
    var tilePosY;
    var tileTexX;
    var tileTexY;
    
    for(var x = startX; x < endX; x++) {
      var bunkerX = x;
      while(bunkerX < 0) {
        bunkerX += this.groundWidth;
      }
      var bunkers = this.ground[bunkerX % this.groundWidth];
      var bunkerDepth = bunkers.length;
      
      tilePosX = (x * this.TILE_WIDTH) - (player.x - halfGameWidth);
      tilePosY = -240 - (player.y - halfGameHeight);
      
      if(bunkerDepth > 0) {
        var surfaceTexX = 4;
        if(x == player.onBunker) {
          surfaceTexX = 4 - Math.floor(player.lidOpenness / 2);
        }
        var surfaceTexY = ((player.hasBunker && x == player.myBunker) ? 1 : 2);
  
        img.drawSprite("surface", tilePosX, tilePosY, this.TILE_WIDTH, 240, surfaceTexX, surfaceTexY);
      } else {
        img.drawSprite("surface", tilePosX, tilePosY, this.TILE_WIDTH, 240, 0, 0);
      }
      
      
      for(var y = startY; y < bunkerDepth; y++) {
        if(y >= 0) {
          tilePosY = (y * this.TILE_HEIGHT) - (player.y - halfGameHeight);
          img.draw("backWall", tilePosX + 18, tilePosY + 40);
          if(bunkers[y].type != "A") {
            tileTexX = 0;
            tileTexY = this.tilesTextureOffset[bunkers[y].type];
            img.drawSprite("rooms", tilePosX + 18, tilePosY + 40, 204, 100, tileTexX, tileTexY);
            if(player.hasBunker && x == player.myBunker) {
              bunker.rooms[y].drawFigures(tilePosX, tilePosY);
            }
          }
          
          tileTexX = 0;
          tileTexY = (y == (bunkerDepth - 1) ? 0 : 1);
          img.drawSprite("tiles", tilePosX, tilePosY, this.TILE_WIDTH, this.TILE_HEIGHT, tileTexX, tileTexY);
          
          if(!player.hasBunker || x != player.myBunker) {
            c.globalAlpha = 0.8;
            img.drawSprite("ground", tilePosX, tilePosY, this.TILE_WIDTH, this.TILE_HEIGHT, 0, 0);
            c.globalAlpha = 1;
          }
        }
      }
      
      
      for(var y = bunkerDepth; y < endY; y++) {
        tilePosY = (y * this.TILE_HEIGHT) - (player.y - halfGameHeight);
        tileTexX = x % 4;
        tileTexY = y % 4;
        img.drawSprite("ground", tilePosX, tilePosY, this.TILE_WIDTH, this.TILE_HEIGHT, tileTexX, tileTexY);
      }
      
      
      if(x == player.onBunker &&
          player.hasBunker &&
          x == player.myBunker &&
          !buildScreen.show && 
          player.onRoom == bunkerDepth - 1 &&
          bunker.rooms[0].type == "venti") {
        tilePosY = (bunkerDepth * this.TILE_HEIGHT) - (player.y - halfGameHeight);
        if(mouse.isOver(tilePosX + 20, tilePosY + 20, this.TILE_WIDTH - 40, this.TILE_HEIGHT - 40)) {
          img.drawSprite("buildArrow", tilePosX, tilePosY, this.TILE_WIDTH, this.TILE_HEIGHT, 0, (mouse.down ? 5 : 4));
          this.buildRoomText.setPosition(tilePosX + 120, tilePosY + 100);
          var nextRoomCost = bunker.getNextRoomCost(); 
          this.buildRoomText.text("C " + nextRoomCost.cement + "     M " + nextRoomCost.metal);
          this.buildRoomText.draw();
        } else {
          img.drawSprite("buildArrow", tilePosX, tilePosY, this.TILE_WIDTH, this.TILE_HEIGHT, 0, 3);
        }
      }
      
      
      if(x == player.onBunker &&
          !player.hasBunker &&
          bunkerDepth == 0 &&
          !buildScreen.show && 
          (player.x % this.TILE_WIDTH) >= 80 &&
          (player.x % this.TILE_WIDTH) < 160 &&
          player.inv.cement >= 5 && player.inv.metal >= 2) {
        tilePosY = 0 - (player.y - halfGameHeight);
        if(mouse.isOver(tilePosX + 20, tilePosY + 20, this.TILE_WIDTH - 40, this.TILE_HEIGHT - 40)) {
          img.drawSprite("buildArrow", tilePosX, tilePosY, this.TILE_WIDTH, this.TILE_HEIGHT, 0, (mouse.down ? 2 : 1));
          this.buildRoomText.setPosition(tilePosX + 120, tilePosY + 100);
          this.buildRoomText.text("C 5     M 2");
          this.buildRoomText.draw();
        } else {
          img.drawSprite("buildArrow", tilePosX, tilePosY, this.TILE_WIDTH, this.TILE_HEIGHT, 0, 0);
        }
      }
    }
    
    if(player.hasBunker) {
      var bunkerOffset = (player.myBunker * this.TILE_WIDTH) + 120 - player.x;
      if(bunkerOffset < -600) {
        img.drawSprite("bunkerArrow", 10, 210, 120, 60, 0, 0);
      }
      if(bunkerOffset > 600) {
        img.drawSprite("bunkerArrow", 830, 210, 120, 60, 1, 0);
      }
    }
    
    for(var i = 0; i < this.crates.length; i++) {
      var crateX = this.crates[i] + halfGameWidth - player.x;
      if(crateX > -14 && crateX < game.WIDTH + 14) {
        img.draw("crate", crateX - 14, -68 + halfGameHeight - player.y);
      }
    }
    
    if(player.hasBunker) {
      bunker.draw();
    }
    
    player.draw();
    
  };  
  
}