function Player() {
  
  this.x = 0;
  this.y = 0;
  
  this.speedX = 8;
  this.speedY = 5;
  
  this.fallV = 0;
  
  this.onBunker = 0;
  this.onRoom = -1;
  
  this.lidOpenness = 0;
  
  this.hasBunker = false;
  
  this.myBunker = 0;
  
  this.myName = "Me";
  
  this.iMoved = false;
  
  this.pickedUpInfo = {};
  this.pickedUpInfoCounter = 0;
  this.pickedUpInfoText;
  
  this.manualProductionProgress = 0;
  
  this.airRaidDeath = 0;
  
  this.dir = 1;
  
  this.animation = 0;
  this.moving = false;
  
  
  this.inv = {
    water : 0,
    food : 0,
    biomass : 0,
    cement : 0,
    metal : 0,
    electronics : 0
  };
  
  this.manualProduction = { air : 0, electricity : 0, water : 0, food : 0, biomass : 0, cement : 0, metal : 0, electronics : 0 };
  
  
  this.infoBoxTitle;
  this.infoBoxInventoryWater;
  this.infoBoxInventoryFood;
  this.infoBoxInventoryBiomass;
  this.infoBoxInventoryCement;
  this.infoBoxInventoryMetal;
  this.infoBoxInventoryElectronics;
  
  
  this.init = function() {
    
    this.x = map.TILE_WIDTH * rand(100, map.groundWidth - 100);
    this.y = -40;
    
    this.infoBoxTitle = new Text();
    this.infoBoxTitle.setPosition(740, 41);
    this.infoBoxTitle.setFont("title");
    this.infoBoxTitle.text("your inventory");
    
    this.infoBoxInventoryWater = new Text();
    this.infoBoxInventoryWater.setFont("normal");
    this.infoBoxInventoryWater.setAlignment(Text.RIGHT);
    
    this.infoBoxInventoryFood = new Text();
    this.infoBoxInventoryFood.setFont("normal");
    this.infoBoxInventoryFood.setAlignment(Text.RIGHT);
    
    this.infoBoxInventoryBiomass = new Text();
    this.infoBoxInventoryBiomass.setFont("normal");
    this.infoBoxInventoryBiomass.setAlignment(Text.RIGHT);
    
    this.infoBoxInventoryCement = new Text();
    this.infoBoxInventoryCement.setFont("normal");
    this.infoBoxInventoryCement.setAlignment(Text.RIGHT);
    
    this.infoBoxInventoryMetal = new Text();
    this.infoBoxInventoryMetal.setFont("normal");
    this.infoBoxInventoryMetal.setAlignment(Text.RIGHT);
    
    this.infoBoxInventoryElectronics = new Text();
    this.infoBoxInventoryElectronics.setFont("normal");
    this.infoBoxInventoryElectronics.setAlignment(Text.RIGHT);
    
    this.pickedUpInfoText = new Text();
    this.pickedUpInfoText.setFont("normalDark");
    this.pickedUpInfoText.setAlignment(Text.CENTER);
    
  };
  
  
  this.buildBunker = function() {
    this.myBunker = this.onBunker;
    map.bunkers[this.myBunker] = { owner : this.myName, accessible : true };
    this.lidOpenness = 8;
    
    bunker = new Bunker();
    bunker.init();
    
    var newRoom = { type : "A", upgrade : 0, people: 0 };
    map.ground[this.myBunker].push(newRoom);
    bunker.addRoom(newRoom);
    
    this.hasBunker = true;
  };
  
  this.addRoom = function() {
    var newRoom = { type : "A", upgrade : 0, people: 0 };
    map.ground[this.myBunker].push(newRoom);
    bunker.addRoom(newRoom);
  };
  
  
  this.update = function() {
    
    if(!this.iMoved) {
      hint.setText("I  use arrow or w/a/s/d keys to move.", 1, 1);
    }
    
    if(!this.hasBunker) {
      if(this.inv.cement < 5 || this.inv.metal < 2) {
        hint.setText("I  collect the resources to build a bunker:   5 cement + 2 metal", 1, 0);
      } else {
        hint.setText("I  find a spot for your bunker and click on the arrow to build it.", 1, 0);
      }
      
    }
    
    this.manualProduction = { air : 0, electricity : 0, water : 0, food : 0, biomass : 0, cement : 0, metal : 0, electronics : 0 };
    
    if(this.hasBunker && this.onBunker == this.myBunker && this.onRoom != -1) {
      if(bunker.rooms[this.onRoom].hasProduction) {
        hint.setText("I  hold [space] to produce " + bunker.rooms[this.onRoom].producedGood + " manually.", 1, 1);
        if(keyboard.isPressed(Keyboard.SPACE_BAR)) {
          this.manualProductionProgress++;
          if(this.manualProductionProgress >= 12) {
            this.manualProductionProgress = 12;
          }
          var production = bunker.rooms[this.onRoom].production;
          for(var res in production) {
            var power = 5;
            if(bunker.inv.electricity > 0 || bunker.rooms[this.onRoom].type == "gen") {
              power = 10;
            }
            this.manualProduction[res] = production[res] * power;
          }
        } else {
          this.manualProductionProgress = 0;
        }
      }
    }
    
    var moveUp = (keyboard.isPressed(Keyboard.W) || keyboard.isPressed(Keyboard.ARROW_UP));
    var moveDown = (keyboard.isPressed(Keyboard.S) || keyboard.isPressed(Keyboard.ARROW_DOWN));
    var moveLeft = (keyboard.isPressed(Keyboard.A) || keyboard.isPressed(Keyboard.ARROW_LEFT));
    var moveRight = ( keyboard.isPressed(Keyboard.D) || keyboard.isPressed(Keyboard.ARROW_RIGHT));
    
    var y = this.y;
    var x = this.x % map.TILE_WIDTH;
    var movedX = false;
    
    var bunkerX = Math.floor(this.x / map.TILE_WIDTH);
    while(bunkerX < 0) {
      bunkerX += map.groundWidth;
    }
    this.onBunker = bunkerX % map.groundWidth;
    var thisBunker = map.ground[this.onBunker];
    var thisBunkerInfo = map.bunkers[this.onBunker];
    
    if(this.y > 0 && this.y % map.TILE_HEIGHT >= 68 && this.y % map.TILE_HEIGHT <= 140) {
      this.onRoom = Math.floor(this.y / map.TILE_HEIGHT);
    } else {
      this.onRoom = -1;
    }
    
    this.moving = false;
    
    if(moveLeft && !moveRight && !buildScreen.show && this.airRaidDeath == 0) {
      if(y > -40) {
        if(this.canGetOffLadder(y) && x > 32) {
          this.x -= this.speedX;
          this.dir = 0;
          this.moving = true;
          movedX = true;
        }
      } else {
        this.iMoved = true;
        this.x -= this.speedX;
        this.dir = 0;
        this.moving = true;
        movedX = true;
      }
    }
    if(moveRight && !moveLeft && !buildScreen.show && this.airRaidDeath == 0) {
      if(y > -40) {
        if(this.canGetOffLadder(y) && x < 208) {
          this.x += this.speedX;
          this.dir = 1;
          this.moving = true;
          movedX = true;
        }
      } else {
        this.iMoved = true;
        this.x += this.speedX;
        this.dir = 1;
        this.moving = true;
        movedX = true;
      }
    }
    
    y = this.y;
    
    if(moveUp && !moveDown && !buildScreen.show && this.airRaidDeath == 0) {
      if(y > -40 && this.canClimbLadder(x)) {
        this.y -= this.speedY;
        this.moving = true;
        if(!movedX) {
          this.x = (this.x - x) + 120;
        }
      }
    }
    if(moveDown && !moveUp && !buildScreen.show && this.airRaidDeath == 0) {
      if(thisBunker.length > 0 &&
          thisBunkerInfo.accessible &&
          y < ((thisBunker.length * map.TILE_HEIGHT) - 20) && 
          this.canClimbLadder(x)) {
        this.y += this.speedY;
        this.moving = true;
        if(!movedX) {
          this.x = (this.x - x) + 120;
        }
      }
    }
    
    y = this.y;
    x = this.x % map.TILE_WIDTH;
    if(this.canOnlyClimbLadder(y)) {
      this.x = (this.x - x) + 120;
    }
    
    if(this.x < game.WIDTH) {
      this.x = game.WIDTH;
    }
    
    if(this.x > (map.groundWidth * map.TILE_WIDTH) - game.WIDTH) {
      this.x = (map.groundWidth * map.TILE_WIDTH) - game.WIDTH;
    }
    
    if(this.moving) {
      this.animation++;
      if(this.animation == 12) {
        this.animation = 0;
      }
    } else {
      this.animation = 0;
    }
    
    if(this.canClimbLadder(x)) {
      if(this.y > -40) {
        this.dir = 2;
      } else {
        if(this.dir == 2) {
          this.dir = 1;
        }
      }
    }
    
    if(y > 0 && !this.canClimbLadder(x) && (this.y % map.TILE_HEIGHT) < 140) {
      var maxFall = 140 - (this.y % map.TILE_HEIGHT);
      this.fallV += 2;
      var roundedFallV = this.speedY * Math.ceil(this.fallV / this.speedY);
      if(roundedFallV > maxFall) {
        this.y += maxFall;
        this.fallV = 0;
      } else {
        this.y += roundedFallV;
      }
    } else {
      this.fallV = 0;
    }
    
    x = this.x % map.TILE_WIDTH;
    
    if(map.ground[this.onBunker].length > 0 &&
        map.bunkers[this.onBunker].accessible &&
        x >= 60 && x < 180 &&
        y <= 20) {
      if(this.onBunker == this.myBunker && this.lidOpenness < 8) {
        this.lidOpenness++;
      }
    } else if(this.lidOpenness > 0) {
      this.lidOpenness--;
    }
    
    
    for(var i = 0; i < map.crates.length; i++) {
      var crateX = map.crates[i];
      if(crateX < player.x - (game.WIDTH * 4)) {
        map.crates[i] += (game.WIDTH * 6);
        crateX = map.crates[i];
      }
      if(crateX > player.x + (game.WIDTH * 4)) {
        map.crates[i] -= (game.WIDTH * 6);
        crateX = map.crates[i];
      }
      if(crateX > this.x - 20 && crateX < this.x + 20) {
        var ressources = ["cement", "metal", "biomass", "cement", "metal", "biomass", "electronics"];
        var ressource = ressources[rand(0, 1)];
        var ressourceAmount = rand(4, 12);
        if(this.hasBunker && bunker.hadPopulation) {
          ressource = ressources[rand(0, 6)];
          ressourceAmount = rand(8, 20);
        }
        if(ressource == "biomass") {
          ressourceAmount = rand(4, 12);
        }
        if(ressource == "electronics") {
          ressourceAmount = rand(1, 2);
        }
        this.inv[ressource] += ressourceAmount;
        
        var ressourceIcons = { cement : "C + ", metal : "M + ", biomass : "B + ", electronics : "L + " };
        this.pickedUpInfoCounter++;
        this.pickedUpInfo[this.pickedUpInfoCounter] = { countdown: 30, x : crateX, text : ressourceIcons[ressource] + ressourceAmount };
        
        var placeCrateX = rand(0.6 * game.WIDTH, 1.6 * game.WIDTH);
        if(rand(0, 1) == 0) {
          map.placeCrate(i, player.x + placeCrateX);
        } else {
          map.placeCrate(i, player.x - placeCrateX);
        }
      } 
      
    }
    
    if(this.airRaidDeath > 0) {
      this.airRaidDeath--;
      if(this.airRaidDeath == 90) {
        this.inv = { water : 0, food : 0, biomass : 0, cement : 0, metal : 0, electronics : 0 };
        this.x = (this.myBunker * map.TILE_WIDTH) + 120;
        this.y = 140;
        hint.setText("V  you were severely injured in the air raid. you lost all resources you were carrying.", 180, 4);
      }
    }
    
    
    if(this.onBunker == this.myBunker && this.y > -10) {
      for(var res in this.inv) {
        if(this.inv[res] > 0 && bunker.inv[res] < bunker.maxStorage) {
          if(res == "water" || res == "food") {
            this.inv[res] -= 10;
            bunker.inv[res] += 10;
          } else {
            this.inv[res]--;
            bunker.inv[res]++;
          }
        }
      }
    }
  };
  
  
  this.canClimbLadder = function(x) {
    return (x >= 104 && x < 136);
  };
  
  
  this.canGetOffLadder = function(y) {
    y = y % map.TILE_HEIGHT;
    return (y >= 68 && y <= 140);
  };
  
  
  this.canOnlyClimbLadder = function(y) {
    if(y <= -40) {
      return false;
    } else if(y < 0) {
      return true;
    } else {
      y = y % map.TILE_HEIGHT;
      return (y < 68 || y > 140);
    }
  };
  
  
  this.draw = function() {
    if(this.moving) {
      if(this.dir == 2) {
        img.drawSprite("player", (game.WIDTH / 2) - 12, (game.HEIGHT / 2) - 36, 24, 36, 1 + (Math.floor(this.animation / 3) % 2), this.dir);
      } else {
        img.drawSprite("player", (game.WIDTH / 2) - 12, (game.HEIGHT / 2) - 36, 24, 36, 1 + Math.floor(this.animation / 3), this.dir);
      }      
    } else {
      img.drawSprite("player", (game.WIDTH / 2) - 12, (game.HEIGHT / 2) - 36, 24, 36, 0, this.dir);
    }
    
    for(var i in this.pickedUpInfo) {
      if(this.pickedUpInfo[i].countdown <= 0) {
        delete this.pickedUpInfo[i];
      } else {
        this.pickedUpInfo[i].countdown--;
        var info = this.pickedUpInfo[i];
        this.pickedUpInfoText.setPosition(info.x + (game.WIDTH / 2) - player.x, 212 + info.countdown);
        this.pickedUpInfoText.text(info.text);
        if(info.countdown < 15) {
          c.globalAlpha = info.countdown / 15;
        }
        this.pickedUpInfoText.draw();
        if(info.countdown < 10) {
          c.globalAlpha = 1;
        }
      }
    }
  };
  
  
  this.drawInfoBox = function() {
    
    var boxHeight = 0;
    
    for(var res in this.inv) {
      if(this.inv[res] > 0) {
        boxHeight += 22;
      }
    }
    
    if(boxHeight > 0) {
      
      img.drawSprite("inventory", 680, 0, 300, 96 + boxHeight, 0, 0);
      img.drawSprite("inventory", 680, 96 + boxHeight, 300, 50, 0, 9);
      
      this.infoBoxTitle.draw();
      
      var offset = 0;
      
      if(this.inv.water > 0) {
        img.drawSprite("items", 744, 88 + offset, 16, 16, 2, 0);
        this.infoBoxInventoryWater.setPosition(822, 84 + offset);
        this.infoBoxInventoryWater.text(this.inv.water.toString());
        this.infoBoxInventoryWater.draw();
        
        if(mouse.isOver(740, 85 + offset, 90, 22)) {
          hint.setText("W  water", 1, 2);
        }
        
        offset += 22;
      }
      
      if(this.inv.food > 0) {
        img.drawSprite("items", 744, 88 + offset, 16, 16, 3, 0);
        this.infoBoxInventoryFood.setPosition(822, 84 + offset);
        this.infoBoxInventoryFood.text(this.inv.food.toString());
        this.infoBoxInventoryFood.draw();
        
        if(mouse.isOver(740, 85 + offset, 90, 22)) {
          hint.setText("F  food", 1, 2);
        }
        
        offset += 22;
      }
      
      if(this.inv.biomass > 0) {
        img.drawSprite("items", 744, 88 + offset, 16, 16, 4, 0);
        this.infoBoxInventoryBiomass.setPosition(822, 84 + offset);
        this.infoBoxInventoryBiomass.text(this.inv.biomass.toString());
        this.infoBoxInventoryBiomass.draw();
        
        if(mouse.isOver(740, 85 + offset, 90, 22)) {
          hint.setText("B  biomass", 1, 2);
        }
        
        offset += 22;
      }
      
      if(this.inv.cement > 0) {
        img.drawSprite("items", 744, 88 + offset, 16, 16, 5, 0);
        this.infoBoxInventoryCement.setPosition(822, 84 + offset);
        this.infoBoxInventoryCement.text(this.inv.cement.toString());
        this.infoBoxInventoryCement.draw();
        
        if(mouse.isOver(740, 85 + offset, 90, 22)) {
          hint.setText("C  cement", 1, 2);
        }
        
        offset += 22;
      }
      
      if(this.inv.metal > 0) {
        img.drawSprite("items", 744, 88 + offset, 16, 16, 6, 0);
        this.infoBoxInventoryMetal.setPosition(822, 84 + offset);
        this.infoBoxInventoryMetal.text(this.inv.metal.toString());
        this.infoBoxInventoryMetal.draw();
        
        if(mouse.isOver(740, 85 + offset, 90, 22)) {
          hint.setText("M  metal", 1, 2);
        }
        
        offset += 22;
      }
      
      if(this.inv.electronics > 0) {
        img.drawSprite("items", 744, 88 + offset, 16, 16, 7, 0);
        this.infoBoxInventoryElectronics.setPosition(822, 84 + offset);
        this.infoBoxInventoryElectronics.text(this.inv.electronics.toString());
        this.infoBoxInventoryElectronics.draw();
        
        if(mouse.isOver(740, 85 + offset, 90, 22)) {
          hint.setText("L  electronics", 1, 2);
        }
        
        offset += 22;
      }
    }
    
  };
  
  
  this.drawDeath = function() {
    if(this.airRaidDeath > 0) {
      if(this.airRaidDeath >= 90) {
        c.globalAlpha = 1 - ((this.airRaidDeath - 90) / 30);
      } else {
        c.globalAlpha = (this.airRaidDeath / 90);
      }
      c.fillStyle = "#000";
      c.fillRect(0, 0, game.WIDTH, game.HEIGHT);
      c.globalAlpha = 1;
    }
  };
  
}